;--------------------------------------------------------
; File Created by ZCCC : free open source ANSI-C Compiler
; Version 3.6.0 #Dec 22 2021 (MSVC)
;--------------------------------------------------------
; MC8X port for the RISC core
;--------------------------------------------------------
;	.file	"EEPROM_WRITE_READ.C"
	list	p=M8P626
	radix dec
	include "M8P626.inc"
;--------------------------------------------------------
; external declarations
;--------------------------------------------------------
	extern	_INDF0bits
	extern	_FSR0bits
	extern	_TKCTR0bits
	extern	_TKCTR1bits
	extern	_TKCNTLbits
	extern	_TKCNTHbits
	extern	_TKCHSLbits
	extern	_TKCHSHbits
	extern	_INDF1bits
	extern	_FSR1bits
	extern	_PCLbits
	extern	_STATUSbits
	extern	_OPTIONbits
	extern	_OSCMbits
	extern	_WDTCbits
	extern	_IOBICRbits
	extern	_INDF2bits
	extern	_HBUFbits
	extern	_PDBbits
	extern	_INTCR0bits
	extern	_INTF0bits
	extern	_INTCR1bits
	extern	_INTF1bits
	extern	_IOAbits
	extern	_OEAbits
	extern	_PUAbits
	extern	_ANSAbits
	extern	_IOBbits
	extern	_OEBbits
	extern	_PUBbits
	extern	_ANSBbits
	extern	_IOCbits
	extern	_OECbits
	extern	_PUCbits
	extern	_ANSCbits
	extern	_IOIDSbits
	extern	_I2CADRbits
	extern	_I2CCONbits
	extern	_I2CBUFbits
	extern	_PWM0CRbits
	extern	_PWM0Dbits
	extern	_TXCRbits
	extern	_TXREGbits
	extern	_RXCRbits
	extern	_RXREGbits
	extern	_BRGDHbits
	extern	_BRGDLbits
	extern	_ADCON0bits
	extern	_ADCON1bits
	extern	_ADCON2bits
	extern	_T1CRbits
	extern	_TC1CLbits
	extern	_TC1CHbits
	extern	_T0CRbits
	extern	_TC0CLbits
	extern	_TC0CHbits
	extern	_PWM1DEADbits
	extern	_PWM1Sbits
	extern	_PWM1CRbits
	extern	_PWM1DLbits
	extern	_PWM1DHbits
	extern	_EECON1bits
	extern	_EECON2bits
	extern	_VREFCALbits
	extern	_IRCCALbits
	extern	_R_EEPROM_Read_Data
	extern	_INDF0
	extern	_FSR0
	extern	_TKCTR0
	extern	_TKCTR1
	extern	_TKCNTL
	extern	_TKCNTH
	extern	_TKCHSL
	extern	_TKCHSH
	extern	_INDF1
	extern	_FSR1
	extern	_PCL
	extern	_STATUS
	extern	_OPTION
	extern	_OSCM
	extern	_WDTC
	extern	_IOBICR
	extern	_INDF2
	extern	_HBUF
	extern	_PDB
	extern	_INTCR0
	extern	_INTF0
	extern	_INTCR1
	extern	_INTF1
	extern	_IOA
	extern	_OEA
	extern	_PUA
	extern	_ANSA
	extern	_IOB
	extern	_OEB
	extern	_PUB
	extern	_ANSB
	extern	_IOC
	extern	_OEC
	extern	_PUC
	extern	_ANSC
	extern	_IOIDS
	extern	_I2CADR
	extern	_I2CCON
	extern	_I2CBUF
	extern	_PWM0CR
	extern	_PWM0D
	extern	_TXCR
	extern	_TXREG
	extern	_RXCR
	extern	_RXREG
	extern	_BRGDH
	extern	_BRGDL
	extern	_ADCON0
	extern	_ADCON1
	extern	_ADL
	extern	_ADH
	extern	_ADCON2
	extern	_T1CR
	extern	_TC1CL
	extern	_TC1CH
	extern	_T0CR
	extern	_TC0CL
	extern	_TC0CH
	extern	_PWM1DEAD
	extern	_PWMDEADT
	extern	_PWM1S
	extern	_PWM1CR
	extern	_PWM1DL
	extern	_PWM1DH
	extern	_EECON1
	extern	_EECON2
	extern	_VREFCAL
	extern	_IRCCAL

	extern STK11
	extern STK10
	extern STK09
	extern STK08
	extern STK07
	extern STK06
	extern STK05
	extern STK04
	extern STK03
	extern STK02
	extern STK01
	extern STK00
;--------------------------------------------------------
; global declarations
;--------------------------------------------------------
	global	_EEPROM_Write_Byte
	global	_EEPROM_Read_Check
	global	_W_EEP_Data

;--------------------------------------------------------
; global definitions
;--------------------------------------------------------
UD_EEPROM_WRITE_READ_0	udata
_W_EEP_Data	res	1

;--------------------------------------------------------
; absolute symbol definitions
;--------------------------------------------------------
;--------------------------------------------------------
; compiler-defined variables
;--------------------------------------------------------
UDL_EEPROM_WRITE_READ_0	udata
r0x1002	res	1
r0x1003	res	1
r0x1004	res	1
r0x1005	res	1
;--------------------------------------------------------
; initialized data
;--------------------------------------------------------

;@Allocation info for local variables in function 'EEPROM_Write_Byte'
;@EEPROM_Write_Byte EEPROM_Write_Byte         Allocated to registers ;size:2
;@EEPROM_Write_Byte INDF0bits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte FSR0bits                  Allocated to registers ;size:1
;@EEPROM_Write_Byte TKCTR0bits                Allocated to registers ;size:1
;@EEPROM_Write_Byte TKCTR1bits                Allocated to registers ;size:1
;@EEPROM_Write_Byte TKCNTLbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte TKCNTHbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte TKCHSLbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte TKCHSHbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte INDF1bits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte FSR1bits                  Allocated to registers ;size:1
;@EEPROM_Write_Byte PCLbits                   Allocated to registers ;size:1
;@EEPROM_Write_Byte STATUSbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte OPTIONbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte OSCMbits                  Allocated to registers ;size:1
;@EEPROM_Write_Byte WDTCbits                  Allocated to registers ;size:1
;@EEPROM_Write_Byte IOBICRbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte INDF2bits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte HBUFbits                  Allocated to registers ;size:1
;@EEPROM_Write_Byte PDBbits                   Allocated to registers ;size:1
;@EEPROM_Write_Byte INTCR0bits                Allocated to registers ;size:1
;@EEPROM_Write_Byte INTF0bits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte INTCR1bits                Allocated to registers ;size:1
;@EEPROM_Write_Byte INTF1bits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte IOAbits                   Allocated to registers ;size:1
;@EEPROM_Write_Byte OEAbits                   Allocated to registers ;size:1
;@EEPROM_Write_Byte PUAbits                   Allocated to registers ;size:1
;@EEPROM_Write_Byte ANSAbits                  Allocated to registers ;size:1
;@EEPROM_Write_Byte IOBbits                   Allocated to registers ;size:1
;@EEPROM_Write_Byte OEBbits                   Allocated to registers ;size:1
;@EEPROM_Write_Byte PUBbits                   Allocated to registers ;size:1
;@EEPROM_Write_Byte ANSBbits                  Allocated to registers ;size:1
;@EEPROM_Write_Byte IOCbits                   Allocated to registers ;size:1
;@EEPROM_Write_Byte OECbits                   Allocated to registers ;size:1
;@EEPROM_Write_Byte PUCbits                   Allocated to registers ;size:1
;@EEPROM_Write_Byte ANSCbits                  Allocated to registers ;size:1
;@EEPROM_Write_Byte IOIDSbits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte I2CADRbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte I2CCONbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte I2CBUFbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM0CRbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM0Dbits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte TXCRbits                  Allocated to registers ;size:1
;@EEPROM_Write_Byte TXREGbits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte RXCRbits                  Allocated to registers ;size:1
;@EEPROM_Write_Byte RXREGbits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte BRGDHbits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte BRGDLbits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte ADCON0bits                Allocated to registers ;size:1
;@EEPROM_Write_Byte ADCON1bits                Allocated to registers ;size:1
;@EEPROM_Write_Byte ADCON2bits                Allocated to registers ;size:1
;@EEPROM_Write_Byte T1CRbits                  Allocated to registers ;size:1
;@EEPROM_Write_Byte TC1CLbits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte TC1CHbits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte T0CRbits                  Allocated to registers ;size:1
;@EEPROM_Write_Byte TC0CLbits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte TC0CHbits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM1DEADbits              Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM1Sbits                 Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM1CRbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM1DLbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM1DHbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte EECON1bits                Allocated to registers ;size:1
;@EEPROM_Write_Byte EECON2bits                Allocated to registers ;size:1
;@EEPROM_Write_Byte VREFCALbits               Allocated to registers ;size:1
;@EEPROM_Write_Byte IRCCALbits                Allocated to registers ;size:1
;@EEPROM_Write_Byte W_EEP_Data                Allocated to registers ;size:1
;@EEPROM_Write_Byte R_EEPROM_Read_Data        Allocated to registers ;size:1
;@EEPROM_Write_Byte W_Data                    Allocated to registers r0x1002 ;size:1
;@EEPROM_Write_Byte R_Save_Option             Allocated to registers r0x1003 ;size:1
;@EEPROM_Write_Byte R_Save_Intcr0             Allocated to registers r0x1004 ;size:1
;@EEPROM_Write_Byte R_Save_Intcr1             Allocated to registers r0x1005 ;size:1
;@EEPROM_Write_Byte INDF0                     Allocated to registers ;size:1
;@EEPROM_Write_Byte FSR0                      Allocated to registers ;size:1
;@EEPROM_Write_Byte TKCTR0                    Allocated to registers ;size:1
;@EEPROM_Write_Byte TKCTR1                    Allocated to registers ;size:1
;@EEPROM_Write_Byte TKCNTL                    Allocated to registers ;size:1
;@EEPROM_Write_Byte TKCNTH                    Allocated to registers ;size:1
;@EEPROM_Write_Byte TKCHSL                    Allocated to registers ;size:1
;@EEPROM_Write_Byte TKCHSH                    Allocated to registers ;size:1
;@EEPROM_Write_Byte INDF1                     Allocated to registers ;size:1
;@EEPROM_Write_Byte FSR1                      Allocated to registers ;size:1
;@EEPROM_Write_Byte PCL                       Allocated to registers ;size:1
;@EEPROM_Write_Byte STATUS                    Allocated to registers ;size:1
;@EEPROM_Write_Byte OPTION                    Allocated to registers ;size:1
;@EEPROM_Write_Byte OSCM                      Allocated to registers ;size:1
;@EEPROM_Write_Byte WDTC                      Allocated to registers ;size:1
;@EEPROM_Write_Byte IOBICR                    Allocated to registers ;size:1
;@EEPROM_Write_Byte INDF2                     Allocated to registers ;size:1
;@EEPROM_Write_Byte HBUF                      Allocated to registers ;size:1
;@EEPROM_Write_Byte PDB                       Allocated to registers ;size:1
;@EEPROM_Write_Byte INTCR0                    Allocated to registers ;size:1
;@EEPROM_Write_Byte INTF0                     Allocated to registers ;size:1
;@EEPROM_Write_Byte INTCR1                    Allocated to registers ;size:1
;@EEPROM_Write_Byte INTF1                     Allocated to registers ;size:1
;@EEPROM_Write_Byte IOA                       Allocated to registers ;size:1
;@EEPROM_Write_Byte OEA                       Allocated to registers ;size:1
;@EEPROM_Write_Byte PUA                       Allocated to registers ;size:1
;@EEPROM_Write_Byte ANSA                      Allocated to registers ;size:1
;@EEPROM_Write_Byte IOB                       Allocated to registers ;size:1
;@EEPROM_Write_Byte OEB                       Allocated to registers ;size:1
;@EEPROM_Write_Byte PUB                       Allocated to registers ;size:1
;@EEPROM_Write_Byte ANSB                      Allocated to registers ;size:1
;@EEPROM_Write_Byte IOC                       Allocated to registers ;size:1
;@EEPROM_Write_Byte OEC                       Allocated to registers ;size:1
;@EEPROM_Write_Byte PUC                       Allocated to registers ;size:1
;@EEPROM_Write_Byte ANSC                      Allocated to registers ;size:1
;@EEPROM_Write_Byte IOIDS                     Allocated to registers ;size:1
;@EEPROM_Write_Byte I2CADR                    Allocated to registers ;size:1
;@EEPROM_Write_Byte I2CCON                    Allocated to registers ;size:1
;@EEPROM_Write_Byte I2CBUF                    Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM0CR                    Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM0D                     Allocated to registers ;size:1
;@EEPROM_Write_Byte TXCR                      Allocated to registers ;size:1
;@EEPROM_Write_Byte TXREG                     Allocated to registers ;size:1
;@EEPROM_Write_Byte RXCR                      Allocated to registers ;size:1
;@EEPROM_Write_Byte RXREG                     Allocated to registers ;size:1
;@EEPROM_Write_Byte BRGDH                     Allocated to registers ;size:1
;@EEPROM_Write_Byte BRGDL                     Allocated to registers ;size:1
;@EEPROM_Write_Byte ADCON0                    Allocated to registers ;size:1
;@EEPROM_Write_Byte ADCON1                    Allocated to registers ;size:1
;@EEPROM_Write_Byte ADL                       Allocated to registers ;size:1
;@EEPROM_Write_Byte ADH                       Allocated to registers ;size:1
;@EEPROM_Write_Byte ADCON2                    Allocated to registers ;size:1
;@EEPROM_Write_Byte T1CR                      Allocated to registers ;size:1
;@EEPROM_Write_Byte TC1CL                     Allocated to registers ;size:1
;@EEPROM_Write_Byte TC1CH                     Allocated to registers ;size:1
;@EEPROM_Write_Byte T0CR                      Allocated to registers ;size:1
;@EEPROM_Write_Byte TC0CL                     Allocated to registers ;size:1
;@EEPROM_Write_Byte TC0CH                     Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM1DEAD                  Allocated to registers ;size:1
;@EEPROM_Write_Byte PWMDEADT                  Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM1S                     Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM1CR                    Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM1DL                    Allocated to registers ;size:1
;@EEPROM_Write_Byte PWM1DH                    Allocated to registers ;size:1
;@EEPROM_Write_Byte EECON1                    Allocated to registers ;size:1
;@EEPROM_Write_Byte EECON2                    Allocated to registers ;size:1
;@EEPROM_Write_Byte VREFCAL                   Allocated to registers ;size:1
;@EEPROM_Write_Byte IRCCAL                    Allocated to registers ;size:1
;@end Allocation info for local variables in function 'EEPROM_Write_Byte';

;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;	udata_ovr
;--------------------------------------------------------
; code
;--------------------------------------------------------
code_EEPROM_WRITE_READ	code
;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_EEPROM_WRITE_READ__EEPROM_Read_Check	code
_EEPROM_Read_Check:	;Function start
; 2 exit points
;	.line	71; EEPROM_WRITE_READ.C	FSR1 = 0x08;
	MOVIA	0x08
	MOVAR	_FSR1
;	.line	72; EEPROM_WRITE_READ.C	FSR0 = 0x00;
	CLRR	_FSR0
;	.line	73; EEPROM_WRITE_READ.C	IOA0 = 0;
	BCLR	_IOAbits,0
;	.line	74; EEPROM_WRITE_READ.C	EEMOD = 1;                            //读EE，需置位
	BSET	_EECON1bits,7
;	.line	75; EEPROM_WRITE_READ.C	__RDT();
	RDT
;	.line	76; EEPROM_WRITE_READ.C	EEMOD = 0;      	                  //写完EE，清除该位
	BCLR	_EECON1bits,7
;	.line	79; EEPROM_WRITE_READ.C	__endasm;	
	;
	movar	_R_EEPROM_Read_Data
	
;	.line	80; EEPROM_WRITE_READ.C	return(R_EEPROM_Read_Data);
	MOVR	_R_EEPROM_Read_Data,0
	RETURN	
; exit point of _EEPROM_Read_Check

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;5 compiler assigned registers:
;   r0x1002
;   r0x1003
;   r0x1004
;   r0x1005
;   r0x1006
;; Starting pCode block
S_EEPROM_WRITE_READ__EEPROM_Write_Byte	code
_EEPROM_Write_Byte:	;Function start
; 2 exit points
	MOVAR	_W_EEP_Data
;	.line	30; EEPROM_WRITE_READ.C	void EEPROM_Write_Byte(unsigned char W_Data)
	MOVAR	r0x1002
;	.line	35; EEPROM_WRITE_READ.C	R_Save_Option = OPTION;
	MOVR	_OPTION,0
	MOVAR	r0x1003
;	.line	36; EEPROM_WRITE_READ.C	R_Save_Intcr0 = INTCR0;
	MOVR	_INTCR0,0
	MOVAR	r0x1004
;	.line	37; EEPROM_WRITE_READ.C	R_Save_Intcr1 = INTCR1;
	MOVR	_INTCR1,0
	MOVAR	r0x1005
;	.line	38; EEPROM_WRITE_READ.C	OPTION = 0x00;						  //关闭所有中断
	CLRR	_OPTION
;	.line	39; EEPROM_WRITE_READ.C	INTCR0 = 0x00; 
	CLRR	_INTCR0
;	.line	40; EEPROM_WRITE_READ.C	INTCR1 = 0x00;
	CLRR	_INTCR1
;	.line	42; EEPROM_WRITE_READ.C	FSR1 = 0x08;
	MOVIA	0x08
	MOVAR	_FSR1
;	.line	43; EEPROM_WRITE_READ.C	FSR0 = 0x00;	
	CLRR	_FSR0
;;102	MOVR	r0x1002,0
;	.line	47; EEPROM_WRITE_READ.C	__endasm;
	;
	movr	_W_EEP_Data,a
	
;	.line	48; EEPROM_WRITE_READ.C	EEMOD = 1;                            //读写EE/MTP时需置位
	BSET	_EECON1bits,7
;	.line	49; EEPROM_WRITE_READ.C	EEWEN = 1;                            //使能EE/MTP写入
	BSET	_EECON1bits,0
;	.line	50; EEPROM_WRITE_READ.C	EELOCK3 = 1;                          //EE/MTP写入解锁流程1
	BSET	_EECON2bits,3
;	.line	51; EEPROM_WRITE_READ.C	EELOCK2 = 1;                          //EE/MTP写入解锁流程2
	BSET	_EECON2bits,2
;	.line	52; EEPROM_WRITE_READ.C	EELOCK1 = 1;                          //EE/MTP写入解锁流程3
	BSET	_EECON2bits,1
;	.line	53; EEPROM_WRITE_READ.C	EEWE = 1;       	                  //写入
	BSET	_EECON2bits,0
;	.line	54; EEPROM_WRITE_READ.C	__NOP();                              //CPU暂停，等待EE写入结束
	NOP
;	.line	55; EEPROM_WRITE_READ.C	EEMOD = 0;      	                  //写完EE，清除该位
	BCLR	_EECON1bits,7
;	.line	56; EEPROM_WRITE_READ.C	if(WERR == 1)
	CLRR	r0x1002
	JBTS0	_EECON1bits,1
	INCR	r0x1002,1
;;101	MOVR	r0x1002,0
;;99	MOVAR	r0x1006
;;100	MOVR	r0x1006,0
	MOVR	r0x1002,0
	JCMPAI	0x01
	GOTO	_00106_DS_
;	.line	58; EEPROM_WRITE_READ.C	IOA0 = 1;
	BSET	_IOAbits,0
_00106_DS_:
;	.line	60; EEPROM_WRITE_READ.C	OPTION = R_Save_Option;				  //恢复中断
	MOVR	r0x1003,0
	MOVAR	_OPTION
;	.line	61; EEPROM_WRITE_READ.C	INTCR0 = R_Save_Intcr0;
	MOVR	r0x1004,0
	MOVAR	_INTCR0
;	.line	62; EEPROM_WRITE_READ.C	INTCR1 = R_Save_Intcr1;
	MOVR	r0x1005,0
	MOVAR	_INTCR1
	RETURN	
; exit point of _EEPROM_Write_Byte


;	code size estimation:
;	   43+    0 =    43 instructions (   86 byte)

	end
