;--------------------------------------------------------
; File Created by ZCCC : free open source ANSI-C Compiler
; Version 3.6.0 #Dec 22 2021 (MSVC)
;--------------------------------------------------------
; MC8X port for the RISC core
;--------------------------------------------------------
;	.file	"M8P626_EEPROM.C"
	list	p=M8P626
	radix dec
	include "M8P626.inc"
;--------------------------------------------------------
; external declarations
;--------------------------------------------------------
	extern	_EEPROM_Write_Byte
	extern	_EEPROM_Read_Check
	extern	_INDF0bits
	extern	_FSR0bits
	extern	_TKCTR0bits
	extern	_TKCTR1bits
	extern	_TKCNTLbits
	extern	_TKCNTHbits
	extern	_TKCHSLbits
	extern	_TKCHSHbits
	extern	_INDF1bits
	extern	_FSR1bits
	extern	_PCLbits
	extern	_STATUSbits
	extern	_OPTIONbits
	extern	_OSCMbits
	extern	_WDTCbits
	extern	_IOBICRbits
	extern	_INDF2bits
	extern	_HBUFbits
	extern	_PDBbits
	extern	_INTCR0bits
	extern	_INTF0bits
	extern	_INTCR1bits
	extern	_INTF1bits
	extern	_IOAbits
	extern	_OEAbits
	extern	_PUAbits
	extern	_ANSAbits
	extern	_IOBbits
	extern	_OEBbits
	extern	_PUBbits
	extern	_ANSBbits
	extern	_IOCbits
	extern	_OECbits
	extern	_PUCbits
	extern	_ANSCbits
	extern	_IOIDSbits
	extern	_I2CADRbits
	extern	_I2CCONbits
	extern	_I2CBUFbits
	extern	_PWM0CRbits
	extern	_PWM0Dbits
	extern	_TXCRbits
	extern	_TXREGbits
	extern	_RXCRbits
	extern	_RXREGbits
	extern	_BRGDHbits
	extern	_BRGDLbits
	extern	_ADCON0bits
	extern	_ADCON1bits
	extern	_ADCON2bits
	extern	_T1CRbits
	extern	_TC1CLbits
	extern	_TC1CHbits
	extern	_T0CRbits
	extern	_TC0CLbits
	extern	_TC0CHbits
	extern	_PWM1DEADbits
	extern	_PWM1Sbits
	extern	_PWM1CRbits
	extern	_PWM1DLbits
	extern	_PWM1DHbits
	extern	_EECON1bits
	extern	_EECON2bits
	extern	_VREFCALbits
	extern	_IRCCALbits
	extern	_INDF0
	extern	_FSR0
	extern	_TKCTR0
	extern	_TKCTR1
	extern	_TKCNTL
	extern	_TKCNTH
	extern	_TKCHSL
	extern	_TKCHSH
	extern	_INDF1
	extern	_FSR1
	extern	_PCL
	extern	_STATUS
	extern	_OPTION
	extern	_OSCM
	extern	_WDTC
	extern	_IOBICR
	extern	_INDF2
	extern	_HBUF
	extern	_PDB
	extern	_INTCR0
	extern	_INTF0
	extern	_INTCR1
	extern	_INTF1
	extern	_IOA
	extern	_OEA
	extern	_PUA
	extern	_ANSA
	extern	_IOB
	extern	_OEB
	extern	_PUB
	extern	_ANSB
	extern	_IOC
	extern	_OEC
	extern	_PUC
	extern	_ANSC
	extern	_IOIDS
	extern	_I2CADR
	extern	_I2CCON
	extern	_I2CBUF
	extern	_PWM0CR
	extern	_PWM0D
	extern	_TXCR
	extern	_TXREG
	extern	_RXCR
	extern	_RXREG
	extern	_BRGDH
	extern	_BRGDL
	extern	_ADCON0
	extern	_ADCON1
	extern	_ADL
	extern	_ADH
	extern	_ADCON2
	extern	_T1CR
	extern	_TC1CL
	extern	_TC1CH
	extern	_T0CR
	extern	_TC0CL
	extern	_TC0CH
	extern	_PWM1DEAD
	extern	_PWMDEADT
	extern	_PWM1S
	extern	_PWM1CR
	extern	_PWM1DL
	extern	_PWM1DH
	extern	_EECON1
	extern	_EECON2
	extern	_VREFCAL
	extern	_IRCCAL
	extern	__zccc_gsinit_startup
;--------------------------------------------------------
; global declarations
;--------------------------------------------------------
	global	_Clr_RAM_00H_7FH
	global	_System_Init
	global	_main
	global	_int_isr
	global	_R_EEPROM_Read_Data
	global	_R_Save_Stk00
	global	_R_Save_Stk01
	global	_R_Save_Stk02
	global	_R_Save_Stk03
	global	_R_Save_Stk04
	global	_R_Save_Stk05
	global	_R_Save_Stk06
	global	_R_Save_Stk07
	global	_R_Save_Stk08
	global	_R_Save_Stk09
	global	_R_Save_Stk10
	global	_R_Save_Stk11
	global	_R_Save_Fsr0
	global	_R_Save_Fsr1
	global	_R_Save_Hbuf

	global STK11
	global STK10
	global STK09
	global STK08
	global STK07
	global STK06
	global STK05
	global STK04
	global STK03
	global STK02
	global STK01
	global STK00

sharebank udata_ovr 0x0000
STK11	res 1
STK10	res 1
STK09	res 1
STK08	res 1
STK07	res 1
STK06	res 1
STK05	res 1
STK04	res 1
STK03	res 1
STK02	res 1
STK01	res 1
STK00	res 1

;--------------------------------------------------------
; global definitions
;--------------------------------------------------------
UD_M8P626_EEPROM_0	udata
_R_EEPROM_Read_Data	res	1

UD_M8P626_EEPROM_1	udata
_R_Save_Stk00	res	1

UD_M8P626_EEPROM_2	udata
_R_Save_Stk01	res	1

UD_M8P626_EEPROM_3	udata
_R_Save_Stk02	res	1

UD_M8P626_EEPROM_4	udata
_R_Save_Stk03	res	1

UD_M8P626_EEPROM_5	udata
_R_Save_Stk04	res	1

UD_M8P626_EEPROM_6	udata
_R_Save_Stk05	res	1

UD_M8P626_EEPROM_7	udata
_R_Save_Stk06	res	1

UD_M8P626_EEPROM_8	udata
_R_Save_Stk07	res	1

UD_M8P626_EEPROM_9	udata
_R_Save_Stk08	res	1

UD_M8P626_EEPROM_10	udata
_R_Save_Stk09	res	1

UD_M8P626_EEPROM_11	udata
_R_Save_Stk10	res	1

UD_M8P626_EEPROM_12	udata
_R_Save_Stk11	res	1

UD_M8P626_EEPROM_13	udata
_R_Save_Fsr0	res	1

UD_M8P626_EEPROM_14	udata
_R_Save_Fsr1	res	1

UD_M8P626_EEPROM_15	udata
_R_Save_Hbuf	res	1

;--------------------------------------------------------
; absolute symbol definitions
;--------------------------------------------------------
;--------------------------------------------------------
; compiler-defined variables
;--------------------------------------------------------
UDL_M8P626_EEPROM_0	udata
r0x1003	res	1
;--------------------------------------------------------
; initialized data
;--------------------------------------------------------

;@Allocation info for local variables in function 'main'
;@main System_Init               Allocated to registers ;size:2
;@main Clr_RAM_00H_7FH           Allocated to registers ;size:2
;@main EEPROM_Write_Byte         Allocated to registers ;size:2
;@main EEPROM_Read_Check         Allocated to registers ;size:2
;@main main                      Allocated to registers ;size:2
;@main INDF0bits                 Allocated to registers ;size:1
;@main FSR0bits                  Allocated to registers ;size:1
;@main TKCTR0bits                Allocated to registers ;size:1
;@main TKCTR1bits                Allocated to registers ;size:1
;@main TKCNTLbits                Allocated to registers ;size:1
;@main TKCNTHbits                Allocated to registers ;size:1
;@main TKCHSLbits                Allocated to registers ;size:1
;@main TKCHSHbits                Allocated to registers ;size:1
;@main INDF1bits                 Allocated to registers ;size:1
;@main FSR1bits                  Allocated to registers ;size:1
;@main PCLbits                   Allocated to registers ;size:1
;@main STATUSbits                Allocated to registers ;size:1
;@main OPTIONbits                Allocated to registers ;size:1
;@main OSCMbits                  Allocated to registers ;size:1
;@main WDTCbits                  Allocated to registers ;size:1
;@main IOBICRbits                Allocated to registers ;size:1
;@main INDF2bits                 Allocated to registers ;size:1
;@main HBUFbits                  Allocated to registers ;size:1
;@main PDBbits                   Allocated to registers ;size:1
;@main INTCR0bits                Allocated to registers ;size:1
;@main INTF0bits                 Allocated to registers ;size:1
;@main INTCR1bits                Allocated to registers ;size:1
;@main INTF1bits                 Allocated to registers ;size:1
;@main IOAbits                   Allocated to registers ;size:1
;@main OEAbits                   Allocated to registers ;size:1
;@main PUAbits                   Allocated to registers ;size:1
;@main ANSAbits                  Allocated to registers ;size:1
;@main IOBbits                   Allocated to registers ;size:1
;@main OEBbits                   Allocated to registers ;size:1
;@main PUBbits                   Allocated to registers ;size:1
;@main ANSBbits                  Allocated to registers ;size:1
;@main IOCbits                   Allocated to registers ;size:1
;@main OECbits                   Allocated to registers ;size:1
;@main PUCbits                   Allocated to registers ;size:1
;@main ANSCbits                  Allocated to registers ;size:1
;@main IOIDSbits                 Allocated to registers ;size:1
;@main I2CADRbits                Allocated to registers ;size:1
;@main I2CCONbits                Allocated to registers ;size:1
;@main I2CBUFbits                Allocated to registers ;size:1
;@main PWM0CRbits                Allocated to registers ;size:1
;@main PWM0Dbits                 Allocated to registers ;size:1
;@main TXCRbits                  Allocated to registers ;size:1
;@main TXREGbits                 Allocated to registers ;size:1
;@main RXCRbits                  Allocated to registers ;size:1
;@main RXREGbits                 Allocated to registers ;size:1
;@main BRGDHbits                 Allocated to registers ;size:1
;@main BRGDLbits                 Allocated to registers ;size:1
;@main ADCON0bits                Allocated to registers ;size:1
;@main ADCON1bits                Allocated to registers ;size:1
;@main ADCON2bits                Allocated to registers ;size:1
;@main T1CRbits                  Allocated to registers ;size:1
;@main TC1CLbits                 Allocated to registers ;size:1
;@main TC1CHbits                 Allocated to registers ;size:1
;@main T0CRbits                  Allocated to registers ;size:1
;@main TC0CLbits                 Allocated to registers ;size:1
;@main TC0CHbits                 Allocated to registers ;size:1
;@main PWM1DEADbits              Allocated to registers ;size:1
;@main PWM1Sbits                 Allocated to registers ;size:1
;@main PWM1CRbits                Allocated to registers ;size:1
;@main PWM1DLbits                Allocated to registers ;size:1
;@main PWM1DHbits                Allocated to registers ;size:1
;@main EECON1bits                Allocated to registers ;size:1
;@main EECON2bits                Allocated to registers ;size:1
;@main VREFCALbits               Allocated to registers ;size:1
;@main IRCCALbits                Allocated to registers ;size:1
;@main R_EEPROM_Read_Data        Allocated to registers ;size:1
;@main R_Save_Stk00              Allocated to registers ;size:1
;@main R_Save_Stk01              Allocated to registers ;size:1
;@main R_Save_Stk02              Allocated to registers ;size:1
;@main R_Save_Stk03              Allocated to registers ;size:1
;@main R_Save_Stk04              Allocated to registers ;size:1
;@main R_Save_Stk05              Allocated to registers ;size:1
;@main R_Save_Stk06              Allocated to registers ;size:1
;@main R_Save_Stk07              Allocated to registers ;size:1
;@main R_Save_Stk08              Allocated to registers ;size:1
;@main R_Save_Stk09              Allocated to registers ;size:1
;@main R_Save_Stk10              Allocated to registers ;size:1
;@main R_Save_Stk11              Allocated to registers ;size:1
;@main R_Save_Fsr0               Allocated to registers ;size:1
;@main R_Save_Fsr1               Allocated to registers ;size:1
;@main R_Save_Hbuf               Allocated to registers ;size:1
;@main R_EEPROM_Data             Allocated to registers r0x1003 ;size:1
;@main INDF0                     Allocated to registers ;size:1
;@main FSR0                      Allocated to registers ;size:1
;@main TKCTR0                    Allocated to registers ;size:1
;@main TKCTR1                    Allocated to registers ;size:1
;@main TKCNTL                    Allocated to registers ;size:1
;@main TKCNTH                    Allocated to registers ;size:1
;@main TKCHSL                    Allocated to registers ;size:1
;@main TKCHSH                    Allocated to registers ;size:1
;@main INDF1                     Allocated to registers ;size:1
;@main FSR1                      Allocated to registers ;size:1
;@main PCL                       Allocated to registers ;size:1
;@main STATUS                    Allocated to registers ;size:1
;@main OPTION                    Allocated to registers ;size:1
;@main OSCM                      Allocated to registers ;size:1
;@main WDTC                      Allocated to registers ;size:1
;@main IOBICR                    Allocated to registers ;size:1
;@main INDF2                     Allocated to registers ;size:1
;@main HBUF                      Allocated to registers ;size:1
;@main PDB                       Allocated to registers ;size:1
;@main INTCR0                    Allocated to registers ;size:1
;@main INTF0                     Allocated to registers ;size:1
;@main INTCR1                    Allocated to registers ;size:1
;@main INTF1                     Allocated to registers ;size:1
;@main IOA                       Allocated to registers ;size:1
;@main OEA                       Allocated to registers ;size:1
;@main PUA                       Allocated to registers ;size:1
;@main ANSA                      Allocated to registers ;size:1
;@main IOB                       Allocated to registers ;size:1
;@main OEB                       Allocated to registers ;size:1
;@main PUB                       Allocated to registers ;size:1
;@main ANSB                      Allocated to registers ;size:1
;@main IOC                       Allocated to registers ;size:1
;@main OEC                       Allocated to registers ;size:1
;@main PUC                       Allocated to registers ;size:1
;@main ANSC                      Allocated to registers ;size:1
;@main IOIDS                     Allocated to registers ;size:1
;@main I2CADR                    Allocated to registers ;size:1
;@main I2CCON                    Allocated to registers ;size:1
;@main I2CBUF                    Allocated to registers ;size:1
;@main PWM0CR                    Allocated to registers ;size:1
;@main PWM0D                     Allocated to registers ;size:1
;@main TXCR                      Allocated to registers ;size:1
;@main TXREG                     Allocated to registers ;size:1
;@main RXCR                      Allocated to registers ;size:1
;@main RXREG                     Allocated to registers ;size:1
;@main BRGDH                     Allocated to registers ;size:1
;@main BRGDL                     Allocated to registers ;size:1
;@main ADCON0                    Allocated to registers ;size:1
;@main ADCON1                    Allocated to registers ;size:1
;@main ADL                       Allocated to registers ;size:1
;@main ADH                       Allocated to registers ;size:1
;@main ADCON2                    Allocated to registers ;size:1
;@main T1CR                      Allocated to registers ;size:1
;@main TC1CL                     Allocated to registers ;size:1
;@main TC1CH                     Allocated to registers ;size:1
;@main T0CR                      Allocated to registers ;size:1
;@main TC0CL                     Allocated to registers ;size:1
;@main TC0CH                     Allocated to registers ;size:1
;@main PWM1DEAD                  Allocated to registers ;size:1
;@main PWMDEADT                  Allocated to registers ;size:1
;@main PWM1S                     Allocated to registers ;size:1
;@main PWM1CR                    Allocated to registers ;size:1
;@main PWM1DL                    Allocated to registers ;size:1
;@main PWM1DH                    Allocated to registers ;size:1
;@main EECON1                    Allocated to registers ;size:1
;@main EECON2                    Allocated to registers ;size:1
;@main VREFCAL                   Allocated to registers ;size:1
;@main IRCCAL                    Allocated to registers ;size:1
;@end Allocation info for local variables in function 'main';

;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;	udata_ovr
;--------------------------------------------------------
; reset vector 
;--------------------------------------------------------
STARTUP	code 0x0000
	goto	__zccc_gsinit_startup
;--------------------------------------------------------
; interrupt and initialization code
;--------------------------------------------------------
c_interrupt	code	0x0008
__sdcc_interrupt:
;***
;  pBlock Stats: dbName = I
;***
;; Starting pCode block
_int_isr:	;Function start
; 0 exit points
;	.line	82; M8P626_EEPROM.C	__PUSH();                    //进栈、保存A、STATUS
	PUSH
;	.line	112; M8P626_EEPROM.C	__endasm;
	;
	MOVR	STK00,0
	MOVAR	_R_Save_Stk00
	MOVR	STK01,0
	MOVAR	_R_Save_Stk01
	MOVR	STK02,0
	MOVAR	_R_Save_Stk02
	MOVR	STK03,0
	MOVAR	_R_Save_Stk03
	MOVR	STK04,0
	MOVAR	_R_Save_Stk04
	MOVR	STK05,0
	MOVAR	_R_Save_Stk05
	MOVR	STK06,0
	MOVAR	_R_Save_Stk06
	MOVR	STK07,0
	MOVAR	_R_Save_Stk07
	MOVR	STK08,0
	MOVAR	_R_Save_Stk08
	MOVR	STK09,0
	MOVAR	_R_Save_Stk09
	MOVR	STK10,0
	MOVAR	_R_Save_Stk10
	MOVR	STK11,0
	MOVAR	_R_Save_Stk11
;	.line	116; M8P626_EEPROM.C	R_Save_Fsr0 = FSR0;
	MOVR	_FSR0,0
	MOVAR	_R_Save_Fsr0
;	.line	117; M8P626_EEPROM.C	R_Save_Fsr1 = FSR1;
	MOVR	_FSR1,0
	MOVAR	_R_Save_Fsr1
;	.line	118; M8P626_EEPROM.C	R_Save_Hbuf = HBUF;
	MOVR	_HBUF,0
	MOVAR	_R_Save_Hbuf
;	.line	123; M8P626_EEPROM.C	__NOP();
	NOP
;	.line	153; M8P626_EEPROM.C	__endasm;
	;
	MOVR	_R_Save_Stk00,0
	MOVAR	STK00
	MOVR	_R_Save_Stk01,0
	MOVAR	STK01
	MOVR	_R_Save_Stk02,0
	MOVAR	STK03
	MOVR	_R_Save_Stk03,0
	MOVAR	STK04
	MOVR	_R_Save_Stk04,0
	MOVAR	STK04
	MOVR	_R_Save_Stk05,0
	MOVAR	STK05
	MOVR	_R_Save_Stk06,0
	MOVAR	STK06
	MOVR	_R_Save_Stk07,0
	MOVAR	STK07
	MOVR	_R_Save_Stk08,0
	MOVAR	STK08
	MOVR	_R_Save_Stk09,0
	MOVAR	STK09
	MOVR	_R_Save_Stk10,0
	MOVAR	STK10
	MOVR	_R_Save_Stk11,0
	MOVAR	STK11
;	.line	157; M8P626_EEPROM.C	FSR0 = R_Save_Fsr0;
	MOVR	_R_Save_Fsr0,0
	MOVAR	_FSR0
;	.line	158; M8P626_EEPROM.C	FSR1 = R_Save_Fsr1;
	MOVR	_R_Save_Fsr1,0
	MOVAR	_FSR1
;	.line	159; M8P626_EEPROM.C	HBUF = R_Save_Hbuf;	
	MOVR	_R_Save_Hbuf,0
	MOVAR	_HBUF
;	.line	163; M8P626_EEPROM.C	__POP();                     //出栈、恢复A、STATUS
	POP
END_OF_INTERRUPT:
	RETIE	

;--------------------------------------------------------
; code
;--------------------------------------------------------
code_M8P626_EEPROM	code
;***
;  pBlock Stats: dbName = M
;***
;has an exit
;functions called:
;   _System_Init
;   _Clr_RAM_00H_7FH
;   _EEPROM_Write_Byte
;   _EEPROM_Read_Check
;   _System_Init
;   _Clr_RAM_00H_7FH
;   _EEPROM_Write_Byte
;   _EEPROM_Read_Check
;1 compiler assigned register :
;   r0x1003
;; Starting pCode block
S_M8P626_EEPROM__main	code
_main:	;Function start
; 2 exit points
;	.line	62; M8P626_EEPROM.C	System_Init();              			//系统初始化
	CALL	_System_Init
;	.line	63; M8P626_EEPROM.C	Clr_RAM_00H_7FH();          			//清零RAM
	CALL	_Clr_RAM_00H_7FH
_00108_DS_:
;	.line	66; M8P626_EEPROM.C	__CLRWDT();							//清除看门狗	
	CLRWDT
;	.line	67; M8P626_EEPROM.C	EEPROM_Write_Byte(0x55);    		//EEPROM读写
	MOVIA	0x55
	CALL	_EEPROM_Write_Byte
;	.line	68; M8P626_EEPROM.C	R_EEPROM_Data = EEPROM_Read_Check();//EEPROM读和校验
	CALL	_EEPROM_Read_Check
	MOVAR	r0x1003
;	.line	69; M8P626_EEPROM.C	if(R_EEPROM_Data!=0x55)
	MOVR	r0x1003,0
	JNCMPAI	0x55
	GOTO	_00108_DS_
;	.line	71; M8P626_EEPROM.C	IOA0 = 1;
	BSET	_IOAbits,0
	GOTO	_00108_DS_
	RETURN	
; exit point of _main

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_M8P626_EEPROM__Clr_RAM_00H_7FH	code
_Clr_RAM_00H_7FH:	;Function start
; 2 exit points
;	.line	211; M8P626_EEPROM.C	__endasm; 
	;
Clr_RAM_00H_7FH:
	CLRR	FSR0
Clr_RAM_00H_7FH_LOOP:
	MOVIA	0x00
	MOVAR	INDF0
	INCR	FSR0,1
	JBTS1	FSR0,7
	GOTO	Clr_RAM_00H_7FH_LOOP
	
	RETURN	
; exit point of _Clr_RAM_00H_7FH

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_M8P626_EEPROM__System_Init	code
_System_Init:	;Function start
; 2 exit points
;	.line	176; M8P626_EEPROM.C	OSCM = 0x00;
	CLRR	_OSCM
;	.line	180; M8P626_EEPROM.C	PUA = 0x00;					//0:上拉关闭 1:上拉使能
	CLRR	_PUA
;	.line	181; M8P626_EEPROM.C	OEA = 0xFF;					//0:输入 1:输出 
	MOVIA	0xff
	MOVAR	_OEA
;	.line	182; M8P626_EEPROM.C	IOA = 0x00;					//IO口数据   
	CLRR	_IOA
;	.line	184; M8P626_EEPROM.C	PUB = 0x00;					
	CLRR	_PUB
;	.line	185; M8P626_EEPROM.C	OEB = 0xFF;					 
	MOVIA	0xff
	MOVAR	_OEB
;	.line	186; M8P626_EEPROM.C	IOB = 0x00;					
	CLRR	_IOB
;	.line	188; M8P626_EEPROM.C	PUC = 0x00;					
	CLRR	_PUC
;	.line	189; M8P626_EEPROM.C	OEC = 0xFF;					  
	MOVIA	0xff
	MOVAR	_OEC
;	.line	190; M8P626_EEPROM.C	IOC = 0x00;					
	CLRR	_IOC
;	.line	193; M8P626_EEPROM.C	GIE = 0;					//1:总中断使能,0:屏蔽所有中断
	BCLR	_OPTIONbits,7
	RETURN	
; exit point of _System_Init


;	code size estimation:
;	   41+    0 =    41 instructions (   82 byte)

	end
